/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.service.impl;

import com.rjconsultores.ventaboletos.dao.MarcaClaseServicioDAO;
import com.rjconsultores.ventaboletos.entidad.ClaseServicio;
import com.rjconsultores.ventaboletos.entidad.Empresa;
import com.rjconsultores.ventaboletos.entidad.Marca;
import com.rjconsultores.ventaboletos.entidad.MarcaClaseServicio;
import com.rjconsultores.ventaboletos.entidad.MarcaClaseServicioPK;
import com.rjconsultores.ventaboletos.entidad.Usuario;
import com.rjconsultores.ventaboletos.service.MarcaClaseServicioService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;

import java.util.ArrayList;
import java.util.Calendar;
import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

/**
 *
 * @author Administrador
 */
@Service("marcaClaseServicioService")
public class MarcaClaseServicioServiceImpl implements MarcaClaseServicioService {

    @Autowired
    private MarcaClaseServicioDAO marcaClaseServicioDAO;

    public List<MarcaClaseServicio> obtenerTodos() {
        return marcaClaseServicioDAO.obtenerTodos();
    }

    public MarcaClaseServicio obtenerID(MarcaClaseServicioPK id) {
        return marcaClaseServicioDAO.obtenerID(id);
    }

    @Transactional
    public MarcaClaseServicio suscribir(MarcaClaseServicio entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.TRUE);

        return marcaClaseServicioDAO.suscribir(entidad);
    }

    @Transactional
    public MarcaClaseServicio actualizacion(MarcaClaseServicio entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.TRUE);

        return marcaClaseServicioDAO.actualizacion(entidad);
    }

    @Transactional
    public void borrar(MarcaClaseServicio entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.FALSE);

        marcaClaseServicioDAO.actualizacion(entidad);
    }

    public List<Marca> buscar(ClaseServicio clase) {
        return marcaClaseServicioDAO.buscar(clase);
    }

	@Override
	public List<Marca> buscarPorEmpresasPermitidas(ClaseServicio clase, Usuario usuarioLoggado) {
		List<Integer> idsEmpresa = getIdsEmpresaUsuario(usuarioLoggado);
		return marcaClaseServicioDAO.buscarPorEmpresasPermitidas(clase, idsEmpresa);
	}
	
	private List<Integer> getIdsEmpresaUsuario(Usuario usuario){
		List<Integer> toReturn = new ArrayList<Integer>();
		for(Empresa empresa : usuario.getEmpresa()){
			toReturn.add(empresa.getEmpresaId());
		}
		return toReturn;
	}
}
